--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 7.1.04i
--  \   \         Application : 
--  /   /         Filename : dcm.vhd
-- /___/   /\     Timestamp : 07/28/2006 12:47:51
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: dcm
--
-- Module dcm
-- Generated by Xilinx Architecture Wizard
-- Written for synthesis tool: XST

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.all;
-- synopsys translate_on

entity gdcm is
    port (
        CLKIN_IN        : in  std_logic;
        RST_IN          : in  std_logic;
        CLKDV_OUT       : out std_logic;
        CLKIN_IBUFG_OUT : out std_logic;
        CLK0_OUT        : out std_logic;
        CLKFX_OUT       : out std_logic);
end gdcm;

architecture BEHAVIORAL of gdcm is
    signal CLKDV_BUF   : std_logic;
    signal CLKFX_BUF   : std_logic;
    signal CLKFB_IN    : std_logic;
    signal CLKIN_IBUFG : std_logic;
    signal CLK0_BUF    : std_logic;
    signal GND         : std_logic;
    component BUFG
        port (
            I : in  std_logic;
            O : out std_logic);
    end component BUFG;

    component IBUFG
        port (
            I : in  std_logic;
            O : out std_logic);
    end component IBUFG;

    component DCM
        generic(
            CLK_FEEDBACK          : string     := "1X";
            CLKDV_DIVIDE          : real       := 2.000000;
            CLKFX_DIVIDE          : integer    := 2;
            CLKFX_MULTIPLY        : integer    := 2;
            CLKIN_DIVIDE_BY_2     : boolean    := FALSE;
            CLKIN_PERIOD          : real       := 20.833;
            CLKOUT_PHASE_SHIFT    : string     := "NONE";
            DESKEW_ADJUST         : string     := "SYSTEM_SYNCHRONOUS";
            DFS_FREQUENCY_MODE    : string     := "LOW";
            DLL_FREQUENCY_MODE    : string     := "LOW";
            DUTY_CYCLE_CORRECTION : boolean    := TRUE;
            FACTORY_JF            : bit_vector := x"C080";
            PHASE_SHIFT           : integer    := 0;
            STARTUP_WAIT          : boolean    := FALSE;
            DSS_MODE              : string     := "NONE");
        port (
            CLKIN    : in  std_logic;
            CLKFB    : in  std_logic;
            RST      : in  std_logic;
            PSEN     : in  std_logic;
            PSINCDEC : in  std_logic;
            PSCLK    : in  std_logic;
            DSSEN    : in  std_logic;
            CLK0     : out std_logic;
            CLK90    : out std_logic;
            CLK180   : out std_logic;
            CLK270   : out std_logic;
            CLKDV    : out std_logic;
            CLK2X    : out std_logic;
            CLK2X180 : out std_logic;
            CLKFX    : out std_logic;
            CLKFX180 : out std_logic;
            STATUS   : out std_logic_vector (7 downto 0);
            LOCKED   : out std_logic;
            PSDONE   : out std_logic);
    end component DCM;
    
begin
    GND             <= '0';
    CLKIN_IBUFG_OUT <= CLKIN_IBUFG;
    CLK0_OUT        <= CLKFB_IN;
    CLKDV_BUFG_INST : BUFG
        port map (
            I => CLKDV_BUF,
            O => CLKDV_OUT);

    CLKIN_IBUFG_INST : IBUFG
        port map (
            I => CLKIN_IN,
            O => CLKIN_IBUFG);

    CLK0_BUFG_INST : BUFG
        port map (
            I => CLK0_BUF,
            O => CLKFB_IN);

    CLKFX_BUFG_INST : BUFG
        port map (
            I => CLKFX_BUF,
            O => CLKFX_OUT);

    DCM_INST : DCM
        generic map(
            CLK_FEEDBACK          => "1X",
            CLKDV_DIVIDE          => 10.000000,
            CLKFX_DIVIDE          => 2,
            CLKFX_MULTIPLY        => 2,
            CLKIN_DIVIDE_BY_2     => FALSE,
            CLKIN_PERIOD          => 20.833300,
            CLKOUT_PHASE_SHIFT    => "NONE",
            DESKEW_ADJUST         => "SYSTEM_SYNCHRONOUS",
            DFS_FREQUENCY_MODE    => "LOW",
            DLL_FREQUENCY_MODE    => "LOW",
            DUTY_CYCLE_CORRECTION => TRUE,
            FACTORY_JF            => x"C080",
            PHASE_SHIFT           => 0,
            STARTUP_WAIT          => TRUE)
        port map (
            CLKFB    => CLKFB_IN,
            CLKIN    => CLKIN_IBUFG,
            DSSEN    => GND,
            PSCLK    => GND,
            PSEN     => GND,
            PSINCDEC => GND,
            RST      => RST_IN,
            CLKDV    => CLKDV_BUF,
            CLKFX    => CLKFX_BUF,
            CLKFX180 => open,
            CLK0     => CLK0_BUF,
            CLK2X    => open,
            CLK2X180 => open,
            CLK90    => open,
            CLK180   => open,
            CLK270   => open,
            LOCKED   => open,
            PSDONE   => open,
            STATUS   => open);

end architecture BEHAVIORAL;


